package controllers

import (

	"os"
	"path/filepath"

	"net/http"
	"net/http/httputil"
	"github.com/revel/revel"
)

// App config
var (

	ExeFile	= `WebitelDialerService.exe`
	BinPath	= `bin`
	RunPath	= `run`

	ExePath string
)

type App struct {
	*revel.Controller
}

func (c App) Index() revel.Result {
	return c.Render()
}


func Init() {

	var err error
	
	ExeFile = revel.Config.StringDefault("app.exe", ExeFile)
	BinPath = revel.Config.StringDefault("app.bin", BinPath)
	BinPath = filepath.FromSlash(BinPath)
	if !filepath.IsAbs(BinPath) {
		BinPath = filepath.Join(revel.BasePath, BinPath)
		BinPath, err = filepath.Abs(BinPath)
		if err != nil {
			panic("sql4dialer/app.conf: app.bin = "+ err.Error())
		}
	}
	exeFile := filepath.Join(BinPath, ExeFile)
	if _, err = os.Stat(exeFile); os.IsNotExist(err) {
		panic("sql4dialer/app.conf: app.bin = "+ err.Error())
	}

	RunPath = revel.Config.StringDefault("app.run", RunPath)
	RunPath = filepath.FromSlash(RunPath)
	if !filepath.IsAbs(RunPath) {
		RunPath = filepath.Join(revel.BasePath, RunPath)
		RunPath, err = filepath.Abs(RunPath)
		if err != nil {
			panic("sql4dialer/app.conf: app.run = "+ err.Error())
		}
	}

	err = os.MkdirAll(RunPath, 775)
	if err != nil {
		panic(err)
	}

	revel.AppLog.Infof("\n\n\tapp.exe = %s\n\tapp.bin = %s\n\tapp.run = %s\n", ExeFile, BinPath, RunPath)
}

func init() {

	revel.OnAppStart(Init)
	// testing purpose
	revel.InterceptFunc(dumpRequest, revel.BEFORE, App{})
}

func dumpRequest(c *revel.Controller) revel.Result {
	raw, _ := c.Request.In.GetRaw().(*http.Request)
	data, err := httputil.DumpRequest(raw, true)
	if err != nil {
		panic(err)
	}
	revel.AppLog.Infof(" <<== %s\n\n%s\n%s", raw.RemoteAddr, data, c.Params.JSON)
	return nil
}